//+------------------------------------------------------------------+
//|                                                    ExportCSV.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
//#property version   "1.00"
//#property strict
#property show_inputs

extern int length = 100;   //  ,   
extern datetime StartDate = D'2012.01.01 00:00:00' ;  //     
string nameData;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void start()
  {
//---
    nameData = "Export/"+Symbol()+Period()+".CSV";         //    
    write_data();
  }
//+------------------------------------------------------------------+
void write_data()
{
  int handle;
  handle = FileOpen(nameData, FILE_CSV|FILE_WRITE,';');
  if(handle < 1)
  {
    Comment("   "+nameData+".  #", GetLastError());
    return;
  }
  //FileWrite(handle, ServerAddress(), Symbol(), Period());                  // 
  FileWrite(handle, "DATE","TIME","OPEN","HIGH","LOW","CLOSE","VOLUME");   // 
  int i;
  for (i=length-1; i>=0; i--)
  {
   if (Time[i]<StartDate)continue;
    int BarYear=TimeYear(Time[i]);
    int BarMonth=TimeMonth(Time[i]);
    int BarDay=TimeDay(Time[i]);
    string BarDate = BarDay+"."+BarMonth+"."+BarYear;
    string NewDate = StrTran(BarDate,".","-");
    string DataStr = NewDate+";"+TimeToStr(Time[i], TIME_MINUTES)+";"+Open[i]+";"+High[i]+";"+Low[i]+";"+Close[i];
   string NewData=StrTran(DataStr,".",",");
   FileWrite(handle, NewData, Volume[i]);
  }
  FileClose(handle);
  Comment(" "+nameData+" . "+TimeToStr(TimeCurrent(), TIME_SECONDS) );
  return;
  }
  
 //+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    str     -  ,                   |
//|    strFrom -                                            |
//|    strTo   -                                            |
//+----------------------------------------------------------------------------+
string StrTran(string str, string strFrom, string strTo) {
  int    n;
  string strOut="", strTemp;

  for (n=0; n<StringLen(str); n++) {
    strTemp=StringSubstr(str, n, StringLen(strFrom));
    if (strTemp==strFrom) {
      strOut=StringConcatenate(strOut, strTo);
      n=n+StringLen(strFrom)-1;
    } else strOut=StringConcatenate(strOut, StringSubstr(str, n, 1));
  }
  return(strOut);
}
//+------------------------------------------------------------------+